﻿using System;
using System.Web;
using System.Web.Http;
using System.Web.Http.OData.Builder;
using CRUD.Models;

namespace CRUD.App_Start
{
    public class WebApiConfig
    {
        public static void Register(HttpConfiguration configuration)
        {
            configuration.EnableQuerySupport();
            var modelBuilder = new ODataConventionModelBuilder ();

            var product = modelBuilder.EntitySet<Product>("Products");
            product.EntityType.HasKey(c => c.ProductID);
            product.EntityType.Ignore(p => p.Order_Details);
            product.EntityType.Ignore(p => p.Category);
            product.EntityType.Ignore(p => p.Supplier);           

            var model = modelBuilder.GetEdmModel();
            configuration.Routes.MapODataRoute("ODataRoute", "odata", model);
        }
    }

    public abstract class Test
    {
        protected Test()
        {
            
        }
    }
}