﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.OData;
using System.Web.Http.OData.Query;
using Microsoft.Data.OData;
using Microsoft.Data.OData.Query;
using CRUD.Models;

namespace CRUD.Controllers
{
    public class ProductsController : EntitySetController<Product, int>
    {
        private readonly NORTHWNDEntities _entities = new NORTHWNDEntities();

        [Queryable(AllowedQueryOptions = AllowedQueryOptions.All)]
        public override IQueryable<Product> Get()
        {
            return _entities.Products;
        }

        [Queryable(AllowedQueryOptions = AllowedQueryOptions.All)]
        protected override Product GetEntityByKey(int key)
        {
            return _entities.Products.FirstOrDefault(o => o.ProductID == key);
        }

        [Queryable(AllowedQueryOptions = AllowedQueryOptions.All)]
        protected override Product CreateEntity(Product entity)
        {
            if (entity != null)
            {
                _entities.Products.Add(entity);
                _entities.SaveChanges();
                return entity;
            }
            throw new NullReferenceException();
        }

        protected override int GetKey(Product entity)
        {
            if (entity != null)
                return entity.ProductID;
            throw new NullReferenceException();
        }

        [Queryable(AllowedQueryOptions = AllowedQueryOptions.All)]
        protected override Product UpdateEntity(int key, Product update)
        {
            var product = _entities.Products.FirstOrDefault(e => e.ProductID == key);

            if (product != null)
            {
                product.ProductName = update.ProductName;
                product.CategoryID = update.CategoryID;
                product.QuantityPerUnit = update.QuantityPerUnit;

                _entities.SaveChanges();

                return product;
            }

            throw new KeyNotFoundException();
        }

        public override void Delete(int key)
        {
            _entities.Products.Remove(_entities.Products.FirstOrDefault(p => p.ProductID == key));
            _entities.SaveChanges();
        }
    }
}